<template>
  <v-list-item
    exact
    :to="correctionRoute"
    style="width: 100%"
  >
    <!-- dynamically set css class depending on active -->
    <v-list-item-content
      :class="{'inactive-subscription': !active}"
      class="mr-3 subscription"
    >
      {{ name }}
    </v-list-item-content>
    <v-list-item-action-text>
      left: {{ available }}
    </v-list-item-action-text>
  </v-list-item>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { Assignment , FeedbackStageEnum } from '@/models'
import { Assignments } from '@/store/modules/assignments'

@Component
export default class SubscriptionForList extends Vue {
  @Prop({ type: String, required: true }) name!: string
  @Prop({ type: String, required: true }) sub_type_pk!: string

  get active () {
    return !!this.available
  }

  get available () {
    const stage = Assignments.state.assignmentCreation.stage
    const sub_type = this.sub_type_pk
    const forSubType = Assignments.state.submissionsLeft[sub_type]
    const forStage = forSubType !== undefined ? forSubType[stage] : undefined
    return forStage
  }

  get correctionRoute() {
    if (!this.active)
      return undefined

    const group = Assignments.state.assignmentCreation.group
    const group_pk = group !== undefined ? group.pk : undefined

    return {
      name: 'correction',
      params: {
        sub_type: this.sub_type_pk,
        stage: Assignments.state.assignmentCreation.stage,
        group: group_pk || undefined,
      }
    }
  }
}
</script>

<style scoped>
  .inactive-subscription {
    cursor: default;
    color: #B5B5B5;
  }

  .subscription {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
</style>
